// MessageBoxExplorerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "MessageBoxExplorerDlg.h"
#include "Escapes.h"
#include "ToClip.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define PROCESSALLFLAGS()                                  \
                     PROCESSFLAG(MB_ABORTRETRYIGNORE);     \
                     PROCESSFLAG(MB_CANCELTRYCONTINUE);    \
                     PROCESSFLAG(MB_OK);                   \
                     PROCESSFLAG(MB_OKCANCEL);             \
                     PROCESSFLAG(MB_RETRYCANCEL);          \
                     PROCESSFLAG(MB_YESNO);                \
                     PROCESSFLAG(MB_YESNOCANCEL);          \
                     PROCESSFLAG(MB_HELP);                 \
                     PROCESSFLAG(MB_ICONEXCLAMATION);      \
                     PROCESSFLAG(MB_ICONQUESTION);         \
                     PROCESSFLAG(MB_ICONWARNING);          \
                     PROCESSFLAG(MB_ICONINFORMATION);      \
                     PROCESSFLAG(MB_ICONASTERISK);         \
                     PROCESSFLAG(MB_ICONSTOP);             \
                     PROCESSFLAG(MB_ICONERROR);            \
                     PROCESSFLAG(MB_ICONHAND);             \
                     PROCESSFLAG(MB_USERICON);             \
                     PROCESSFLAG(MB_DEFBUTTON1);           \
                     PROCESSFLAG(MB_DEFBUTTON2);           \
                     PROCESSFLAG(MB_DEFBUTTON3);           \
                     PROCESSFLAG(MB_DEFBUTTON4);           \
                     PROCESSFLAG(MB_APPLMODAL);            \
                     PROCESSFLAG(MB_SYSTEMMODAL);          \
                     PROCESSFLAG(MB_TASKMODAL);            \
                     PROCESSFLAG(MB_RIGHT);                \
                     PROCESSFLAG(MB_RTLREADING);           \
                     PROCESSFLAG(MB_SETFOREGROUND);        \
                     PROCESSFLAG(MB_TOPMOST);
                     

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
        CAboutDlg();

// Dialog Data
        enum { IDD = IDD_ABOUTBOX };

        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
        DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
        CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CMessageBoxExplorerDlg dialog



CMessageBoxExplorerDlg::CMessageBoxExplorerDlg(CWnd* pParent /*=NULL*/)
        : CDialog(CMessageBoxExplorerDlg::IDD, pParent)
{
        m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

/****************************************************************************
*                   CMessageBoxExplorerDlg::DoDataExchange
* Inputs:
*       CDataExchange * pDX:
* Result: void
*       
* Effect: 
*       Binds controls to variables
****************************************************************************/

void CMessageBoxExplorerDlg::DoDataExchange(CDataExchange* pDX)
{
CDialog::DoDataExchange(pDX);
DDX_Control(pDX, IDC_LAUNCH, c_Launch);
DDX_Control(pDX, IDC_RESULT, c_Result);
DDX_Control(pDX, IDC_AFX_MESSAGEBOX, c_AfxMessageBox);
DDX_Control(pDX, IDC_CWND_MESSAGEBOX, c_CWndMessageBox);
DDX_Control(pDX, IDC_MESSAGEBOX, c_MessageBox);
DDX_Control(pDX, IDC_MESSAGEBOXINDIRECT, c_MessageBoxIndirect);
DDX_Control(pDX, IDC_BODY, c_Body);
DDX_Control(pDX, IDC_CAPTION, c_Caption);
DDX_Control(pDX, IDC_CAPTION_CAPTION, x_Caption);
DDX_Control(pDX, IDC_BODY_CAPTION, x_Body);
DDX_Control(pDX, IDC_MB_ABORTRETRYIGNORE, c_MB_ABORTRETRYIGNORE);
DDX_Control(pDX, IDC_MB_CANCELTRYCONTINUE, c_MB_CANCELTRYCONTINUE);
DDX_Control(pDX, IDC_MB_OK, c_MB_OK);
DDX_Control(pDX, IDC_MB_OKCANCEL, c_MB_OKCANCEL);
DDX_Control(pDX, IDC_MB_RETRYCANCEL, c_MB_RETRYCANCEL);
DDX_Control(pDX, IDC_MB_YESNO, c_MB_YESNO);
DDX_Control(pDX, IDC_MB_YESNOCANCEL, c_MB_YESNOCANCEL);
DDX_Control(pDX, IDC_MB_HELP, c_MB_HELP);
DDX_Control(pDX, IDC_MB_ICONEXCLAMATION, c_MB_ICONEXCLAMATION);
DDX_Control(pDX, IDC_MB_ICONQUESTION, c_MB_ICONQUESTION);
DDX_Control(pDX, IDC_MB_ICONWARNING, c_MB_ICONWARNING);
DDX_Control(pDX, IDC_NO_ICON, c_NoIcon);
DDX_Control(pDX, IDC_MB_ICONINFORMATION, c_MB_ICONINFORMATION);
DDX_Control(pDX, IDC_MB_ICONASTERISK, c_MB_ICONASTERISK);
DDX_Control(pDX, IDC_MB_ICONSTOP, c_MB_ICONSTOP);
DDX_Control(pDX, IDC_MB_ICONERROR, c_MB_ICONERROR);
DDX_Control(pDX, IDC_MB_ICONHAND, c_MB_ICONHAND);
DDX_Control(pDX, IDC_MB_USERICON, c_MB_USERICON);
DDX_Control(pDX, IDC_MB_DEFBUTTON1, c_MB_DEFBUTTON1);
DDX_Control(pDX, IDC_MB_DEFBUTTON2, c_MB_DEFBUTTON2);
DDX_Control(pDX, IDC_MB_DEFBUTTON3, c_MB_DEFBUTTON3);
DDX_Control(pDX, IDC_MB_DEFBUTTON4, c_MB_DEFBUTTON4);
DDX_Control(pDX, IDC_MB_APPLMODAL, c_MB_APPLMODAL);
DDX_Control(pDX, IDC_MB_SYSTEMMODAL, c_MB_SYSTEMMODAL);
DDX_Control(pDX, IDC_MB_TASKMODAL, c_MB_TASKMODAL);
DDX_Control(pDX, IDC_MB_RIGHT, c_MB_RIGHT);
DDX_Control(pDX, IDC_MB_RTLREADING, c_MB_RTLREADING);
DDX_Control(pDX, IDC_MB_SETFOREGROUND, c_MB_SETFOREGROUND);
DDX_Control(pDX, IDC_MB_TOPMOST, c_MB_TOPMOST);
DDX_Control(pDX, IDC_ICON_IMAGE, c_Icon);
DDX_Control(pDX, IDC_CODE, c_Code);
DDX_Control(pDX, IDC_COPY, c_Copy);
DDX_Control(pDX, IDC_USE_CAPTION_STRING, c_UseCaptionString);
DDX_Control(pDX, IDC_USE_PROGRAM_CAPTION, c_UseProgramCaption);
DDX_Control(pDX, IDC_CAPTION_STRINGTABLE, c_CaptionStringTable);
DDX_Control(pDX, IDC_USE_CAPTION_STRINGTABLE, c_UseCaptionStringTable);
DDX_Control(pDX, IDC_USE_BODY_STRING, c_UseBodyString);
DDX_Control(pDX, IDC_USE_BODY_STRINGTABLE, c_UseBodyStringTable);
DDX_Control(pDX, IDC_BODY_STRINGTABLE, c_BodyStringTable);
DDX_Control(pDX, IDC_USE_CALLBACK, c_UseCallback);
DDX_Control(pDX, IDC_CALLBACK_GROUP, c_CallbackGroup);
DDX_Control(pDX, IDC_HELP_ID, c_HelpID);
DDX_Control(pDX, IDC_HELP_ID_CAPTION, x_HelpID);
DDX_Control(pDX, IDC_COPY_BODY, c_CopyBody);
DDX_Control(pDX, IDC_COPY_CAPTION, c_CopyCaption);
DDX_Control(pDX, IDC_COPY_ICON, c_CopyIcon);
DDX_Control(pDX, IDC_ICON_CAPTION, x_Icon);
DDX_Control(pDX, IDC_DEFAULT_CAPTION, x_Default);
DDX_Control(pDX, IDC_COPY_DEFAULT, c_CopyDefault);
DDX_Control(pDX, IDC_ZAXIS_CAPTION, x_ZAxis);
DDX_Control(pDX, IDC_COPY_ZAXIS, c_CopyZAxis);
DDX_Control(pDX, IDC_APIS_CAPTION, x_APIs);
DDX_Control(pDX, IDC_COPY_APIS, c_CopyAPIs);
DDX_Control(pDX, IDC_MODALITY_CAPTION, x_Modality);
DDX_Control(pDX, IDC_COPY_MODALITY, c_CopyModality);
DDX_Control(pDX, IDC_ALIGNMENT_CAPTION, x_Alignment);
DDX_Control(pDX, IDC_COPY_ALIGNMENT, c_CopyAlignment);
DDX_Control(pDX, IDC_BUTTONS_CAPTION, x_Buttons);
DDX_Control(pDX, IDC_COPY_BUTTONS, c_CopyButtons);
DDX_Control(pDX, IDC_DEFAULT_CAPTION, x_Default);
DDX_Control(pDX, IDC_COPY_DEFAULT, c_CopyDefault);
DDX_Control(pDX, IDC_COPY_CALLBACK, c_CopyCallback);
DDX_Control(pDX, IDC_COPY_ALL, c_CopyAll);
DDX_Control(pDX, IDC_COPY_PARENT, c_CopyParent);
DDX_Control(pDX, IDC_PARENT_CAPTION, x_Parent);
DDX_Control(pDX, IDC_THIS, c_This);
DDX_Control(pDX, IDC_NULL, c_NULL);
}

/****************************************************************************
*                                 Message Map
****************************************************************************/

BEGIN_MESSAGE_MAP(CMessageBoxExplorerDlg, CDialog)
        ON_WM_SYSCOMMAND()
        ON_WM_PAINT()
        ON_WM_QUERYDRAGICON()
        //}}AFX_MSG_MAP
        ON_WM_CLOSE()
        ON_CONTROL_RANGE(BN_CLICKED, IDC_AFX_MESSAGEBOX, IDC_NULL, OnBnClickedRange)
        ON_BN_CLICKED(IDC_COPY, OnBnClickedCopy)
        ON_BN_CLICKED(IDC_LAUNCH, OnBnClickedLaunch)
        ON_EN_CHANGE(IDC_CAPTION, OnEnChangeCaption)
        ON_EN_CHANGE(IDC_BODY, OnEnChangeBody)
        ON_WM_SIZE()
        ON_CBN_SELENDOK(IDC_CAPTION_STRINGTABLE, OnCbnSelendokCaptionStringtable)
        ON_BN_CLICKED(IDC_COPY_BODY, OnBnClickedCopyBody)
        ON_BN_CLICKED(IDC_COPY_CAPTION, OnBnClickedCopyCaption)
        ON_BN_CLICKED(IDC_COPY_ICON, OnBnClickedCopyIcon)
        ON_BN_CLICKED(IDC_COPY_CALLBACK, OnBnClickedCopyCallback)
        ON_BN_CLICKED(IDC_COPY_DEFAULT, OnBnClickedCopyDefault)
        ON_BN_CLICKED(IDC_COPY_ZAXIS, OnBnClickedCopyZAxis)
        ON_BN_CLICKED(IDC_COPY_APIS, OnBnClickedCopyAPIs)
        ON_BN_CLICKED(IDC_COPY_MODALITY, OnBnClickedCopyModality)
        ON_BN_CLICKED(IDC_COPY_ALIGNMENT, OnBnClickedCopyAlignment)
        ON_BN_CLICKED(IDC_COPY_BUTTONS, OnBnClickedCopyButtons)
        ON_BN_CLICKED(IDC_COPY_ALL, OnBnClickedCopyAll)
        ON_BN_CLICKED(IDC_COPY_PARENT, OnBnClickedCopyParent)
END_MESSAGE_MAP()


// CMessageBoxExplorerDlg message handlers

/****************************************************************************
*                              Dropdown Preloads
****************************************************************************/

#define SAMPLE(ids) { ids, ids##_VALUE }

static const IDData captions[] = {
           SAMPLE(IDS_ERROR),
           SAMPLE(IDS_WARNING),
           SAMPLE(IDS_PROGRAM_BROKEN),
           SAMPLE(IDS_TAKE_NOTE),
           { 0, 0 } // EOT
};

static const IDData bodies[] = {
           SAMPLE(IDS_FILE_OPEN_FAILED),
           SAMPLE(IDS_BROKEN_BODY),
           SAMPLE(IDS_PROCEED_BODY),
           { 0, 0 } // EOT
};

/****************************************************************************
*                   CMessageBoxExplorerDlg::ShowCopyButtons
* Inputs:
*       UINT show: Show option (ignored in release mode)
* Result: void
*       
* Effect: 
*       SHows/hides the copy buttons
****************************************************************************/

void CMessageBoxExplorerDlg::ShowCopyButtons(UINT show)
    {
#ifndef _DEBUG
     show = SW_HIDE;
#endif
     c_CopyBody.ShowWindow(show);
     c_CopyCaption.ShowWindow(show);
     c_CopyIcon.ShowWindow(show);
     c_CopyCallback.ShowWindow(show);
     c_CopyDefault.ShowWindow(show);
     c_CopyZAxis.ShowWindow(show);
     c_CopyAPIs.ShowWindow(show);
     c_CopyModality.ShowWindow(show);
     c_CopyAlignment.ShowWindow(show);
     c_CopyButtons.ShowWindow(show);
     c_CopyAll.ShowWindow(show);
     c_CopyParent.ShowWindow(show);
    } // CMessageBoxExplorerDlg::ShowCopyButtons


/****************************************************************************
*                    CMessageBoxExplorerDlg::OnInitDialog
* Result: BOOL
*       TRUE, always
* Effect: 
*       Initializes the controls
****************************************************************************/

BOOL CMessageBoxExplorerDlg::OnInitDialog()
{
        CDialog::OnInitDialog();

        // Add "About..." menu item to system menu.

        // IDM_ABOUTBOX must be in the system command range.
        ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
        ASSERT(IDM_ABOUTBOX < 0xF000);

        CMenu* pSysMenu = GetSystemMenu(FALSE);
        if (pSysMenu != NULL)
        {
                CString strAboutMenu;
                strAboutMenu.LoadString(IDS_ABOUTBOX);
                if (!strAboutMenu.IsEmpty())
                {
                        pSysMenu->AppendMenu(MF_SEPARATOR);
                        pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
                }
        }

        // Set the icon for this dialog.  The framework does this automatically
        //  when the application's main window is not a dialog
        SetIcon(m_hIcon, TRUE);                 // Set big icon
        SetIcon(m_hIcon, FALSE);                // Set small icon

        // TODO: Add extra initialization here
        CheckRadioButton(IDC_AFX_MESSAGEBOX, IDC_MESSAGEBOXINDIRECT, IDC_AFX_MESSAGEBOX);
        CheckRadioButton(IDC_MB_ABORTRETRYIGNORE, IDC_MB_YESNOCANCEL, IDC_MB_OK);
        CheckRadioButton(IDC_NO_ICON, IDC_MB_USERICON, IDC_NO_ICON);
        CheckRadioButton(IDC_NO_DEFAULT, IDC_MB_DEFBUTTON3, IDC_NO_DEFAULT);
        CheckRadioButton(IDC_DEFAULT_MODAL, IDC_MB_TASKMODAL, IDC_DEFAULT_MODAL);
        CheckRadioButton(IDC_USE_CAPTION_STRING, IDC_USE_CAPTION_STRINGTABLE, IDC_USE_PROGRAM_CAPTION);
        CheckRadioButton(IDC_USE_BODY_STRING, IDC_USE_BODY_STRINGTABLE, IDC_USE_BODY_STRING);
        CheckRadioButton(IDC_THIS, IDC_NULL, IDC_THIS);
        CString s;
        s.LoadString(IDS_BODY);
        s.Replace(_T("\n"), _T("\r\n"));
        c_Body.SetWindowText(s);
        s.LoadString(IDS_CAPTION);
        c_Caption.SetWindowText(s);
        
        HBITMAP bmp = (HBITMAP)::LoadImage(AfxGetInstanceHandle(),
                                   MAKEINTRESOURCE(IDB_COPY),
                                   IMAGE_BITMAP,
                                   0,0,
                                   LR_LOADMAP3DCOLORS);
        c_Copy.SetBitmap(bmp);

        CFont * f = GetFont();
        ASSERT(f != NULL);
        LOGFONT lf;
        f->GetLogFont(&lf);
        StringCchCopy(lf.lfFaceName, LF_FACESIZE, _T("Courier New"));
        font.CreateFontIndirect(&lf);
        c_Code.SetFont(&font);

        c_CaptionStringTable.AddStrings(captions);
        c_CaptionStringTable.SetCurSel(0);

        c_BodyStringTable.AddStrings(bodies);
        c_BodyStringTable.SetCurSel(0);

        //--------------------------------
        // Disable all copy buttons except
        // in debug mode
        //--------------------------------
        //----------------------------------------------------------------
        updateControls();
        return TRUE;  // return TRUE  unless you set the focus to a control
}

/****************************************************************************
*                    CMessageBoxExplorerDlg::OnSysCommand
* Inputs:
*       UINT nID:
*       LPARAM lParam:
* Result: void
*       
* Effect: 
*       Handles the system menu
****************************************************************************/

void CMessageBoxExplorerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
        if ((nID & 0xFFF0) == IDM_ABOUTBOX)
        {
                CAboutDlg dlgAbout;
                dlgAbout.DoModal();
        }
        else
        {
                CDialog::OnSysCommand(nID, lParam);
        }
}

/****************************************************************************
*                       CMessageBoxExplorerDlg::OnPaint
* Result: void
*       
* Effect: 
*       If you add a minimize button to your dialog, you will need the code
*       below to draw the icon.  For MFC applications using the document/view
*       model, this is automatically done for you by the framework.
****************************************************************************/

void CMessageBoxExplorerDlg::OnPaint() 
{
        if (IsIconic())
        {
                CPaintDC dc(this); // device context for painting

                SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

                // Center icon in client rectangle
                int cxIcon = GetSystemMetrics(SM_CXICON);
                int cyIcon = GetSystemMetrics(SM_CYICON);
                CRect rect;
                GetClientRect(&rect);
                int x = (rect.Width() - cxIcon + 1) / 2;
                int y = (rect.Height() - cyIcon + 1) / 2;

                // Draw the icon
                dc.DrawIcon(x, y, m_hIcon);
        }
        else
        {
                CDialog::OnPaint();
        }
}

/****************************************************************************
*                   CMessageBoxExplorerDlg::OnQueryDragIcon
* Result: HCURSOR
*       Cursor or icon handle for dragging
* Effect: 
*       The system calls this function to obtain the cursor to display while
*       the user drags the minimized window.
****************************************************************************/

HCURSOR CMessageBoxExplorerDlg::OnQueryDragIcon()
{
        return static_cast<HCURSOR>(m_hIcon);
}

/****************************************************************************
*                      CMessageBoxExplorerDlg::OnCancel
*                        CMessageBoxExplorerDlg::OnOK
* Result: void
*       
* Effect: 
*       Do nothing.  These keep the app from being closed by an errant
*       <enter> or <esc>
****************************************************************************/

void CMessageBoxExplorerDlg::OnCancel()
{
}

void CMessageBoxExplorerDlg::OnOK()
    {
    }

/****************************************************************************
*                       CMessageBoxExplorerDlg::OnClose
* Result: void
*       
* Effect: 
*       Closes the app
****************************************************************************/

void CMessageBoxExplorerDlg::OnClose()
    {
     CDialog::OnOK();
    }

/****************************************************************************
*                  CMessageBoxExplorerDlg::OnBnClickedRange
* Inputs:
*       UINT id: Control ID
* Result: void
*       
* Effect: 
*       Forces an update
****************************************************************************/

void CMessageBoxExplorerDlg::OnBnClickedRange(UINT id)
    {
     updateControls();
    } // CMessageBoxExplorerDlg::OnBnClickedRange

/****************************************************************************
*                       CMessageBoxExplorerDlg::AddToList
* Inputs:
*       CString & flags: Existing list
*       const CString & name: String to add
*       const CString & sep: separator
* Result: void
*       
* Effect: 
*       Adds the name to the list
****************************************************************************/

void CMessageBoxExplorerDlg::AddToList(CString & flags, const CString & name, const CString & sep)
    {
     if(!flags.IsEmpty())
        flags += sep;
     flags += name;
    } // CMessageBoxExplorerDlg::AddToList

/****************************************************************************
*                      CMessageBoxExplorerDlg::ShowCase
* Inputs:
*       CString & code: Code to append to
*       const CString & casename: Case to add
* Result: 
*       
* Effect: 
*       
****************************************************************************/

void CMessageBoxExplorerDlg::ShowCase(CString & code, const CString & casename)
    {
     CString YourCodeHere;
     YourCodeHere.LoadString(IDS_YOUR_CODE_HERE);

     code += _T("    case ");
     code += casename;
     code += _T(":\r\n        ");
     code += YourCodeHere;
     code += _T("\r\n        break;\r\n");
    } // CMessageBoxExplorerDlg::ShowCase

/****************************************************************************
*                   CMessageBoxExplorerDlg::updateControls
* Result: void
*       
* Effect: 
*       Recomputes the contents of the code display
****************************************************************************/

void CMessageBoxExplorerDlg::updateControls()
    {
     // First, show/hide the copy buttons, then override them
     ShowCopyButtons(SW_SHOW);
     //----------------
     // Caption [.....]
     //----------------

     BOOL wantscaption = FALSE;
     if(c_MessageBox.GetCheck() == BST_CHECKED ||
        c_CWndMessageBox.GetCheck() == BST_CHECKED ||
        c_MessageBoxIndirect.GetCheck() == BST_CHECKED)
        wantscaption = TRUE;

     //----------------------------------
     // +---Caption---------------+
     // |                         |
     //----------------------------------
     UINT visible = wantscaption ? SW_SHOW : SW_HIDE;
     x_Caption.ShowWindow(visible);
#ifdef _DEBUG
     c_CopyCaption.ShowWindow(visible);
#endif
     //----------------------------------
     // [...caption...]
     //----------------------------------
     c_Caption.ShowWindow(visible);

     //----------------------------------
     // +--Body----------------------
     // | (*) Use String
     //----------------------------------

     //----------------------------------
     // +--Body----------------------
     // | ...
     // | ( ) Use STRINGTABLE entry
     //----------------------------------
     c_BodyStringTable.EnableWindow(c_UseBodyStringTable.GetCheck() == BST_CHECKED);

     //----------------------------------
     // +--Caption-------------------
     // | (*) Use String
     //----------------------------------
     c_UseCaptionString.ShowWindow(visible);
     //----------------------------------
     // +--Caption-------------------
     // | ...
     // | ( ) Program Name
     //----------------------------------
     c_UseProgramCaption.ShowWindow(visible);
     //----------------------------------
     // +--Caption-------------------
     // | ...
     // | ( ) STRINGTABLE entry
     //----------------------------------
     c_CaptionStringTable.ShowWindow(visible);
     //----------------------------------
     //                       [IDS_...  |v]
     //----------------------------------
     c_UseCaptionStringTable.ShowWindow(visible);
     c_CaptionStringTable.EnableWindow(c_UseCaptionStringTable.GetCheck() == BST_CHECKED);

     //----------------
     // Launch
     //----------------
     CString body;
     if(c_UseBodyString.GetCheck() == BST_CHECKED)
        { /* use body string */
         c_Body.GetWindowText(body);
        } /* use body string */
     else
     if(c_UseBodyStringTable.GetCheck() == BST_CHECKED)
        { /* use stringtable */
         body.LoadString((int)c_BodyStringTable.GetItemData(c_BodyStringTable.GetCurSel()));
        } /* use stringtable */

     body.Trim();
     body.Replace(_T("\r\n"), _T("\n"));

     CString caption;
     if(c_UseProgramCaption.GetCheck() == BST_CHECKED)
        caption = _T("AfxGetApp()->m_pszAppName");
     else
     if(c_UseCaptionStringTable.GetCheck() == BST_CHECKED)
        caption.LoadString((int)c_CaptionStringTable.GetItemData(c_CaptionStringTable.GetCurSel()));
     else
        { /* string */
         c_Caption.GetWindowText(caption);
         caption.Trim();
        } /* string */
     
     c_Launch.EnableWindow(!body.IsEmpty() && (!wantscaption || !caption.IsEmpty()));
     
     //----------------------------------------------------------------
     // (*) MB_USERICON
     // If we are not in ::MessageBoxIndirect, disable this control
     // If the control is disabled but checked, revert to default
     //----------------------------------------------------------------
     c_MB_USERICON.EnableWindow(c_MessageBoxIndirect.GetCheck() == BST_CHECKED);
     if(c_MessageBoxIndirect.GetCheck() != BST_CHECKED &&
        c_MB_USERICON.GetCheck() == BST_CHECKED)
        CheckRadioButton(IDC_NO_ICON, IDC_MB_USERICON, IDC_NO_ICON);

     visible = c_MessageBoxIndirect.GetCheck() == BST_CHECKED;

     c_HelpID.ShowWindow(visible);
     x_HelpID.ShowWindow(visible);
     c_CallbackGroup.ShowWindow(visible);
     c_UseCallback.ShowWindow(visible);
#ifdef _DEBUG
     c_CopyCallback.ShowWindow(visible);
#endif

     visible = c_MessageBox.GetCheck() == BST_CHECKED ||
               c_MessageBoxIndirect.GetCheck() == BST_CHECKED ? SW_SHOW : SW_HIDE;
     c_This.ShowWindow(visible);
     c_NULL.ShowWindow(visible);
     x_Parent.ShowWindow(visible);
#ifdef _DEBUG
     c_CopyParent.ShowWindow(visible);
#endif

     //----------------
     // Show the icon
     //----------------
     HICON icon = NULL;
     // This handles the special case where "no icon" in AfxMessageBox
     // defaults to IDI_EXCLAMATION
     if(c_NoIcon.GetCheck() == BST_CHECKED &&
        c_AfxMessageBox.GetCheck() == BST_CHECKED)
        icon = AfxGetApp()->LoadStandardIcon(IDI_EXCLAMATION);
     // Otherwise, we only show the icon when it is selected
     if(c_MB_ICONHAND.GetCheck() == BST_CHECKED)
        icon = AfxGetApp()->LoadStandardIcon(IDI_HAND);
     if(c_MB_ICONQUESTION.GetCheck() == BST_CHECKED)
        icon = AfxGetApp()->LoadStandardIcon(IDI_QUESTION);
     if(c_MB_ICONEXCLAMATION.GetCheck() == BST_CHECKED)
        icon = AfxGetApp()->LoadStandardIcon(IDI_EXCLAMATION);
     if(c_MB_ICONASTERISK.GetCheck() == BST_CHECKED)
        icon = AfxGetApp()->LoadStandardIcon(IDI_ASTERISK);
     if(c_MB_ICONSTOP.GetCheck() == BST_CHECKED)
        icon = AfxGetApp()->LoadStandardIcon(IDI_ERROR);
     if(c_MB_ICONWARNING.GetCheck() == BST_CHECKED)
        icon = AfxGetApp()->LoadStandardIcon(IDI_WARNING);
     if(c_MB_ICONERROR.GetCheck() == BST_CHECKED)
        icon = AfxGetApp()->LoadStandardIcon(IDI_ERROR);
     if(c_MB_ICONINFORMATION.GetCheck() == BST_CHECKED)
        icon = AfxGetApp()->LoadStandardIcon(IDI_INFORMATION);
     if(c_MB_USERICON.GetCheck() == BST_CHECKED)
        icon = AfxGetApp()->LoadIcon(MAKEINTRESOURCE(IDI_JMNCO));
     c_Icon.SetIcon(icon);

     //*****************************************************************************
     // COMPUTE THE SAMPLE CODE
     //*****************************************************************************
     // This computes several pieces
     //     declarations - the declarations which must precede the invocation
     //     parameters - the parameter list to the call
     //     flags - the sequence of flags (which get added to parameters)
     //*****************************************************************************
     //----------------
     // code: MessageBoxFunction(
     //----------------
     CString code;
     CString declarations;
     
     if(c_AfxMessageBox.GetCheck() == BST_CHECKED)
        code = _T("switch(AfxMessageBox(");
     else
     if(c_CWndMessageBox.GetCheck() == BST_CHECKED)
        code = _T("switch(MessageBox(");
     else
     if(c_MessageBox.GetCheck() == BST_CHECKED)
        code = _T("switch(::MessageBox(");
     else
     if(c_MessageBoxIndirect.GetCheck() == BST_CHECKED)
        code = _T("switch(::MessageBoxIndirect(");
     else
        { /* failed */
         ASSERT(FALSE);
         code = _T("switch(AfxMessageBox(");
        } /* failed */

     //----------------------------------------------------------------
     // AfxMessageBox(cstring_body, flags);
     // AfxMessageBox(uint_body, flags);
     // MessageBox(cstring_body, cstring_caption, flags);
     // ::MessageBox(hWnd, cstring_body, cstring_caption, flags);
     // ::MessageBoxIndirect(&params)
     //----------------------------------------------------------------
     CString parameters;
     //----------------
     // Compute hWnd-----------+
     //                        |
     //                        V
     // HWND                 hWnd = ...; // compute hwnd here
     // ::MessageBox(        hWnd, 
     // ::MessageBoxIndirect(hWnd,
     //----------------
     CString hwnd;

     if(c_MessageBox.GetCheck() == BST_CHECKED ||
        c_MessageBoxIndirect.GetCheck() == BST_CHECKED)
        { /* ::MessageBox[Indirect] */
         CString s;
         s = _T("HWND hWnd = ");
         if(c_NULL.GetCheck() == BST_CHECKED)
            s += _T("NULL;");
         else
         if(c_This.GetCheck() == BST_CHECKED)
            s += _T("m_hWnd;");
         else
            s.LoadString(IDS_HWND); // HWND hWnd = ...; // comment here            
         AddToList(declarations, s, _T("\r\n"));
         hwnd = _T("hWnd");
         int n = s.Find(_T(" "));
         if(n < 0)
            { /* error */
             ASSERT(FALSE);
            } /* error */
         else
            { /* has hwnd */
             s = s.Mid(n + 1);
             s.Trim();
             n = s.Find(_T(" "));
             if(n >= 0)
                { /* has decl */
                 hwnd = s.Left(n);
                } /* has decl */
            } /* has hwnd */
         AddToList(parameters, hwnd, _T(", "));
        } /* ::MessageBox[Indirect] */

     //--------------------------------
     // compute body----------------+
     //                             |
     //                             V
     // ::MessageBox(hWnd,         body
     // ::MessageBoxIndirect(hWnd, body
     // MessageBox(                body
     // AfxMessageBox(             body-string
     // AfxMessageBox(             body-uint
     //--------------------------------
     if(c_UseBodyString.GetCheck() == BST_CHECKED)
        c_Body.GetWindowText(body);  // get it without pre-trim already applied
     else
     if(c_UseBodyStringTable.GetCheck() == BST_CHECKED)
        body.LoadString((int)c_BodyStringTable.GetItemData(c_BodyStringTable.GetCurSel()));

     body.Replace(_T("\r\n"), _T("\n"));
     EnEscape(body, TRUE);

     CString bodyString = _T("_T(\"") + body + _T("\")");

     CString yourbody;
     yourbody.LoadString(IDS_YOUR_BODY_STRING_HERE);

     if(c_MessageBox.GetCheck() == BST_CHECKED ||
        c_CWndMessageBox.GetCheck() == BST_CHECKED)
        { /* stringtable */
         AddToList(declarations, _T("CString body(") + yourbody + _T(");"), _T("\r\n"));
        } /* stringtable */
     else
     if(c_AfxMessageBox.GetCheck() == BST_CHECKED)
        { /* AfxMessageBox */
         if(c_UseBodyStringTable.GetCheck() == BST_CHECKED)
            { /* stringtable   */
             AddToList(declarations, _T("UINT body = ") + yourbody + _T(";"), _T("\r\n"));
            } /* stringtable   */
         else
            AddToList(declarations, _T("CString body = ") + bodyString + _T(";"), _T("\r\n"));
        } /* AfxMessageBox */
     else
     if(c_MessageBoxIndirect.GetCheck() == BST_CHECKED)
        { /* ::MessageBoxIndirect */
         if(c_UseBodyStringTable.GetCheck() == BST_CHECKED)
            bodyString = _T("MAKEINTRESOURCE(") + yourbody + _T(")");
        } /* ::MessageBoxIndirect */
                           
     AddToList(parameters, _T("body"), _T(", "));

     //--------------------------------
     // compute caption--------------------+
     //                                    |
     //                                    V
     // ::MessageBox(hWnd, body,         caption
     // ::MessageBoxIndirect(hWnd, body, caption
     // MessageBox(                body, caption
     //--------------------------------

     CString captionString;
     c_Caption.GetWindowText(caption);  // get it with pre-trim already applied

     CString yourcaption;
     yourcaption.LoadString(IDS_YOUR_STRING_HERE);

     if(c_UseCaptionStringTable.GetCheck() == BST_CHECKED)
        { /* string table */
         captionString = _T("MAKEINTRESOURCE(") + yourcaption + _T(")");
        } /* string table */
     else
        { /* string */
         EnEscape(caption, TRUE);
         if(c_UseProgramCaption.GetCheck() == BST_CHECKED)
            captionString = _T("AfxGetApp()->m_pszAppName");
         else
            captionString = _T("_T(\"") + caption + _T("\")");
        } /* string */

     //-------------------------------+--------------------------------
     // MessageBox                    |
     // ::MessageBox                  |
     // (*) Use String                | CString caption = _T("string")
     // ( ) Use Program Name          | CString caption = AfxGetApp()->m_pszAppName
     // ( ) STRINGTABLE entry         | CString caption(id)
     //-------------------------------+--------------------------------
     // ::MessageBoxIndirect          |
     // (*) Use String                | params.lpszCaption = _T("string")
     // ( ) Use Program Name          | params.lpszCaption = AfxGetApp()->m_pszAppName
     // ( ) STRINGTABLE entry         | params.lpszCaption = MAKEINTRESOURCE(id)
     //-------------------------------+--------------------------------
     if(c_MessageBox.GetCheck() == BST_CHECKED ||
        c_CWndMessageBox.GetCheck() == BST_CHECKED)
        { /* has caption */
         CString captionDecl;
         if(c_UseCaptionStringTable.GetCheck() == BST_CHECKED)
            { /* id */
             captionDecl = _T("CString caption(") + yourcaption + _T(");");
            } /* id */
         else
            captionDecl = _T("CString caption = ") + captionString + _T(";");

         AddToList(declarations, captionDecl, _T("\r\n"));
         AddToList(parameters, _T("caption"), _T(", "));
        } /* has caption */

     //--------------------------------
     // Flags
     //--------------------------------
     CString flags;
#define PROCESSFLAG(x) {if(c_##x.GetCheck() == BST_CHECKED) AddToList(flags, _T(#x), _T(" | "));}
     PROCESSALLFLAGS()
#undef PROCESSFLAG
     //----------------------
     // construct code
     //----------------------
     AddToList(parameters, flags, _T(", "));
     if(c_MessageBoxIndirect.GetCheck() == BST_CHECKED)
        code += _T("&params");
     else
        code += parameters;

     code += _T("))\r\n");
     code += _T("   { /* message box */\r\n");

     // Compute cases
     //----------------
     // IDABORT
     //----------------
     if(c_MB_ABORTRETRYIGNORE.GetCheck() == BST_CHECKED)
        ShowCase(code, _T("IDABORT"));
     //----------------
     // IDCANCEL
     //----------------
     if(c_MB_OKCANCEL.GetCheck() == BST_CHECKED ||
        c_MB_CANCELTRYCONTINUE.GetCheck() == BST_CHECKED ||
        c_MB_RETRYCANCEL.GetCheck() == BST_CHECKED ||
        c_MB_YESNOCANCEL.GetCheck() == BST_CHECKED)
        ShowCase(code, _T("IDCANCEL"));

     //----------------
     // IDCONTINUE
     //----------------
     if(c_MB_CANCELTRYCONTINUE.GetCheck() == BST_CHECKED)
         ShowCase(code, _T("IDCONTINUE"));
     //----------------
     // IDHELP
     //----------------
     // ... This will not be returned

     //----------------
     // IDIGNORE
     //----------------
     if(c_MB_ABORTRETRYIGNORE.GetCheck() == BST_CHECKED)
         ShowCase(code, _T("IDIGNORE"));
     //----------------
     // IDNO
     //----------------
     if(c_MB_YESNO.GetCheck() == BST_CHECKED ||
        c_MB_YESNOCANCEL.GetCheck() == BST_CHECKED )
        ShowCase(code, _T("IDNO"));
     //----------------
     // IDOK
     //----------------
     if(c_MB_OK.GetCheck() == BST_CHECKED ||
        c_MB_OKCANCEL.GetCheck() == BST_CHECKED )
        ShowCase(code, _T("IDOK"));

     //----------------
     // IDRETRY
     //----------------
     if(c_MB_ABORTRETRYIGNORE.GetCheck() == BST_CHECKED ||
        c_MB_RETRYCANCEL.GetCheck() == BST_CHECKED)
        ShowCase(code, _T("IDTRY"));
     //----------------
     // IDTRYAGAIN
     //----------------
     if(c_MB_CANCELTRYCONTINUE.GetCheck() == BST_CHECKED)
        ShowCase(code, _T("IDTRYAGAIN"));
     //----------------
     // IDYES
     //----------------
     if(c_MB_YESNO.GetCheck() == BST_CHECKED ||
        c_MB_YESNOCANCEL.GetCheck() == BST_CHECKED )
        ShowCase(code, _T("IDYES"));

     code += _T("    default:\r\n        ASSERT(FALSE);\r\n        break;\r\n");
           
     //--------------------------------
     // } /* message box */
     //--------------------------------
     code += _T("   } /* message box */\r\n");
     //--------------------------------
     // MSGBOXPARAMS
     //typedef struct {
     //                UINT cbSize;
     //                HWND hwndOwner;
     //                HINSTANCE hInstance;
     //                LPCTSTR lpszText;
     //                LPCTSTR lpszCaption;
     //                DWORD dwStyle;
     //                LPCTSTR lpszIcon;
     //                DWORD_PTR dwContextHelpId;
     //                MSGBOXCALLBACK lpfnMsgBoxCallback;
     //                DWORD dwLanguageId;
     //} MSGBOXPARAMS, *PMSGBOXPARAMS;
     if(c_MessageBoxIndirect.GetCheck() == BST_CHECKED)
        { /* MsgBoxParams */
         CString MsgBoxParams = _T("MSGBOXPARAMS params;\r\n");
         //----------------
         // cbSize
         //----------------
         MsgBoxParams += _T("params.cbSize = sizeof(params);\r\n");
         //----------------
         // hwndOwner
         //----------------
         MsgBoxParams += _T("params.hwndOwner = ") + hwnd + _T("\r\n");
         //----------------
         // hInstance
         //----------------
         MsgBoxParams += _T("params.hInstance = ");

         if(c_MB_USERICON.GetCheck() == BST_CHECKED ||
            c_UseBodyStringTable.GetCheck() == BST_CHECKED ||
            c_UseCaptionStringTable.GetCheck() == BST_CHECKED)
            MsgBoxParams += _T("AfxGetInstanceHandle();\r\n");
         else
            MsgBoxParams += _T("NULL;\r\n");
         //----------------
         // lpszText
         //----------------
         MsgBoxParams += _T("params.lpszText = ") + bodyString + _T(";\r\n");
         //----------------
         // lpszCaption
         //----------------
         MsgBoxParams += _T("params.lpszCaption = ") + captionString + _T(";\r\n");
         //----------------
         // dwStyle
         //----------------
         MsgBoxParams += _T("params.dwStyle = ") + flags + _T(";\r\n");
         //----------------
         // lpszIcon
         //----------------
         if(c_MB_USERICON.GetCheck() == BST_CHECKED)
            { /* use icon */
             CString youricon;
             youricon.LoadString(IDS_YOUR_ICON_HERE);
             MsgBoxParams += _T("params.lpszIcon = LoadIcon(") + youricon + _T(");\r\n");
            } /* use icon */
         else
            MsgBoxParams += _T("params.lpszIcon = NULL;\r\n");
         //----------------
         // dwContextHelpId
         //----------------
         CString yourhelp;
         yourhelp.LoadString(IDS_YOUR_HELP_ID_HERE);
         MsgBoxParams += _T("params.dwContextHelpID = ") + yourhelp + _T(";\r\n");
         //----------------
         // lpfnMsgBoxCallback
         //----------------
         MsgBoxParams += _T("params.lpfnMsgBoxCallback = NULL;\r\n");
         //----------------
         // dwLanguageId
         //----------------
         MsgBoxParams += _T("params.dwLanguageId = LANG_NEUTRAL;\r\n");
         AddToList(declarations, MsgBoxParams, _T("\r\n"));
        } /* MsgBoxParams */
     //--------------------------------
     // compute complete string
     //--------------------------------
     if(!declarations.IsEmpty())
        code = declarations + _T("\r\n") + code;
     
     c_Code.SetWindowText(code);
    } // CMessageBoxExplorerDlg::updateControls

/****************************************************************************
*                   CMessageBoxExplorerDlg::OnBnClickedCopy
* Result: void
*       
* Effect: 
*       Copies the entire contents of the code sample to the clipboard
****************************************************************************/

void CMessageBoxExplorerDlg::OnBnClickedCopy()
    {
     c_Code.SetRedraw(FALSE);
     int low;
     int high;
     c_Code.GetSel(low, high);
     c_Code.SetSel(0, -1);
     c_Code.SendMessage(WM_COPY);
     c_Code.SetSel(low, high);
     c_Code.SetRedraw(TRUE);
    }

/****************************************************************************
*                  CMessageBoxExplorerDlg::OnBnClickedLaunch
* Result: void
*       
* Effect: 
*       Launches the messagebox
****************************************************************************/

void CMessageBoxExplorerDlg::OnBnClickedLaunch()
    {
     CString caption;
     c_Caption.GetWindowText(caption);
     CString body;
     c_Body.GetWindowText(body);

     DWORD flags = 0;
#define PROCESSFLAG(x) {if(c_##x.GetCheck() == BST_CHECKED) flags |= x;}     
     PROCESSALLFLAGS();
#undef PROCESSFLAG
     
     HWND wnd = NULL;
     if(c_This.GetCheck() == BST_CHECKED)
        wnd = m_hWnd;
     
     c_Result.SetWindowText(_T(""));

     //--------------------------------
     // Compute caption
     //--------------------------------

     UINT captionId = 0;

     if(c_UseCaptionStringTable.GetCheck() == BST_CHECKED)
        { /* use string table */
         int n = c_CaptionStringTable.GetCurSel();
         if(n != CB_ERR)
            captionId = (UINT)c_CaptionStringTable.GetItemData(n);

         if(captionId != 0)
            caption.LoadString(captionId);
         else
            caption = _T("");
        } /* use string table */
     else
     if(c_UseProgramCaption.GetCheck() == BST_CHECKED)
        caption = AfxGetApp()->m_pszAppName;

     //--------------------------------
     // Compute body
     //--------------------------------

     UINT bodyId = 0;

     if(c_UseBodyStringTable.GetCheck() == BST_CHECKED)
        { /* use string table */
         int n = c_BodyStringTable.GetCurSel();
         if(n != CB_ERR)
            bodyId = (UINT)c_BodyStringTable.GetItemData(n);

         if(bodyId != 0)
            body.LoadString(captionId);
         else
            body = _T("");
        } /* use string table */
     
     MSGBOXPARAMS params;
     //----------------
     // params.cbSize
     //----------------
     params.cbSize = sizeof(params);
     //----------------
     // params.hwndOwner
     //----------------
     params.hwndOwner = wnd;
     //----------------
     // params.hInstance
     //----------------
     params.hInstance = AfxGetInstanceHandle();

     //----------------
     // params.lpszText
     //----------------
     if(c_UseBodyStringTable.GetCheck() == BST_CHECKED)
        params.lpszText = MAKEINTRESOURCE(bodyId);
     else
        params.lpszText = body;

     //----------------
     // params.lpszCaption
     //----------------
     if(c_UseCaptionStringTable.GetCheck() == BST_CHECKED)
        params.lpszCaption = MAKEINTRESOURCE(captionId);
     else
        params.lpszCaption = caption;
     //----------------
     // params.dwStyle
     //----------------
     params.dwStyle = flags;
     //----------------
     // params.lpszIcon
     //----------------
     if(c_MB_USERICON.GetCheck() == BST_CHECKED)
        params.lpszIcon = MAKEINTRESOURCE(IDI_JMNCO);
     else
        params.lpszIcon = NULL;
     //----------------
     // params.dwContextHelpId
     //----------------
     params.dwContextHelpId = 0;  // TODO: something with contexts
     //----------------
     // params.lpfnMsgBoxCallback
     //----------------
     params.lpfnMsgBoxCallback = NULL;
     if(c_UseCallback.GetCheck() == BST_CHECKED)
        params.lpfnMsgBoxCallback = HelpCallback;
     //----------------
     // params.dwLanguageId
     //----------------
     params.dwLanguageId = LANG_NEUTRAL; // TODO: enum languages
     
     //****************************************************************
     // Launch MessageBox
     //****************************************************************
     int result;
     if(c_AfxMessageBox.GetCheck() == BST_CHECKED)
        { /* AfxMessageBox  */
         if(c_UseBodyStringTable.GetCheck() == BST_CHECKED)
            result = AfxMessageBox(bodyId, flags);
         else
            result = AfxMessageBox(body, flags);
        } /* AfxMessageBox  */
     else
     if(c_CWndMessageBox.GetCheck() == BST_CHECKED)
        { /* MessageBox */
         result = MessageBox(body, caption, flags);
        } /* MessageBox */
     else
     if(c_MessageBox.GetCheck() == BST_CHECKED)
        { /* ::MessageBox */
         result = ::MessageBox(wnd, body, caption, flags);
        } /* ::MessageBox */
     else
     if(c_MessageBoxIndirect.GetCheck() == BST_CHECKED)
        { /* ::MessageBoxIndirect */
         result = ::MessageBoxIndirect(&params);
        } /* ::MessageBoxIndirect */

     //****************************************************************
     // analyze the result
     //****************************************************************
     CString msg;
     msg.Format(_T("%d"), result);

     switch(result)
        { /* result */
#define RESULTCASE(x) case x: msg += _T(": "); msg += _T(#x); break
         RESULTCASE(IDABORT);
         RESULTCASE(IDCANCEL);
         RESULTCASE(IDCONTINUE);
         RESULTCASE(IDHELP);
         RESULTCASE(IDIGNORE);
         RESULTCASE(IDNO);
         RESULTCASE(IDOK);
         RESULTCASE(IDRETRY);
         RESULTCASE(IDTRYAGAIN);
         RESULTCASE(IDYES);
        } /* result */
     c_Result.SetWindowText(msg);
     
    }

/****************************************************************************
*                  CMessageBoxExplorerDlg::OnEnChangeCaption
* Result: void
*       
* Effect: 
*       The caption selection changed
****************************************************************************/

void CMessageBoxExplorerDlg::OnEnChangeCaption()
    {
     updateControls();
    }

/****************************************************************************
*                   CMessageBoxExplorerDlg::OnEnChangeBody
* Result: void
*       
* Effect: 
*       Forces an update
****************************************************************************/

void CMessageBoxExplorerDlg::OnEnChangeBody()
    {
     updateControls();
    }

/****************************************************************************
*                       CMessageBoxExplorerDlg::OnSize
* Inputs:
*       UINT nType:
*       int cx:
*       int cy:
* Result: void
*       
* Effect: 
*       Resizes the edit control at the bottom
****************************************************************************/

void CMessageBoxExplorerDlg::OnSize(UINT nType, int cx, int cy)
    {
     CDialog::OnSize(nType, cx, cy);

     if(c_Code.GetSafeHwnd() != NULL)
        { /* resize */
         CRect r;
         c_Code.GetWindowRect(&r);
         ScreenToClient(&r);
         c_Code.SetWindowPos(NULL, 0, 0,
                             cx, cy - r.top,
                             SWP_NOMOVE | SWP_NOZORDER);
        } /* resize */
    }

/****************************************************************************
*           CMessageBoxExplorerDlg::OnCbnSelendokCaptionStringTable
* Result: void
*       
* Effect: 
*       Updates the display
****************************************************************************/

void CMessageBoxExplorerDlg::OnCbnSelendokCaptionStringtable()
    {
     updateControls();
    }

/****************************************************************************
*                    CMessageBoxExplorerDlg::HelpCallback
* Inputs:
*       LPHELPINFO info: Help info structure
* Result: void
*       
* Effect: 
*       Handles the help callback
* Notes:
* typedef struct tagHELPINFO       // Structure pointed to by lParam of WM_HELP
*   {
*    UINT    cbSize;               // Size in bytes of this struct 
*    int     iContextType;         // Either HELPINFO_WINDOW or HELPINFO_MENUITEM 
*    int     iCtrlId;              // Control Id or a Menu item Id. 
*    HANDLE  hItemHandle;          // hWnd of control or hMenu.     
*    DWORD   dwContextId;          // Context Id associated with this item 
*    POINT   MousePos;             // Mouse Position in screen co-ordinates 
*   }  HELPINFO, FAR *LPHELPINFO;
****************************************************************************/

/* static */ void CALLBACK CMessageBoxExplorerDlg::HelpCallback(LPHELPINFO info)
    {
     CString fmt;
     fmt.LoadString(IDS_HELP_CALLBACK_FORMAT);
     //UINT    cbSize = %d\nint    iContextType = %s\nint     iCtrlId = %d\n
     // HANDLE  hItemHandle = %p\nDWORD   dwContextId = %d\nPOINT   MousePos = (%d, %d)
     CString msg;
     CString ContextType;
     CString ContextDisplay;
     
     switch(info->iContextType)
        { /* iContextType */
         case HELPINFO_MENUITEM:
            ContextType = _T("HELPINFO_MENUITEM");
            break;
         case HELPINFO_WINDOW:
            { /* window */
             ContextType = _T("HELPINFO_WINDOW");

             CWnd * w = CWnd::FromHandle((HWND)info->hItemHandle);
             ASSERT(w != NULL);
             if(w != NULL)
                { /* use value */
                 CString title;
                 w->GetWindowText(title);
                 ContextDisplay = _T(" (\"") + title + _T("\")");
                } /* use value */
            } /* window */
            break;
         default:
            ContextType.Format(_T("%d"), info->iContextType);
            break;
        } /* iContextType */
     msg.Format(fmt,
                info->cbSize,
                ContextType,
                info->iCtrlId,
                info->hItemHandle,
                ContextDisplay,
                info->dwContextId,
                info->MousePos.x,
                info->MousePos.y);

     switch(AfxMessageBox(msg, MB_ICONINFORMATION | MB_OKCANCEL))
        { /* msgbox */
         case IDOK:
            break;
         case IDCANCEL:
            return;
        } /* msgbox */
     
     switch(info->iContextType)
        { /* response context */
         case HELPINFO_MENUITEM:
            // TODO: figure out what to do here, such as create a test
            return;
         case HELPINFO_WINDOW:
            break;
         default:
            ASSERT(FALSE);
            return;
        } /* response context */

     CWnd * w = CWnd::FromHandle((HWND)info->hItemHandle);

    } // CMessageBoxExplorerDlg::HelpCallback

void CMessageBoxExplorerDlg::OnBnClickedCopyBody()
    {
     toClipboard(&x_Body, TRUE);
    }

void CMessageBoxExplorerDlg::OnBnClickedCopyCaption()
   {
    toClipboard(&x_Caption, TRUE);
   }

void CMessageBoxExplorerDlg::OnBnClickedCopyIcon()
   {
    toClipboard(&x_Icon, TRUE);
   }
   
void CMessageBoxExplorerDlg::OnBnClickedCopyCallback()
   {
    toClipboard(&c_CallbackGroup, TRUE);
   }

void CMessageBoxExplorerDlg::OnBnClickedCopyDefault()
   {
    toClipboard(&x_Default, TRUE);
   }

void CMessageBoxExplorerDlg::OnBnClickedCopyZAxis()
   {
    toClipboard(&x_ZAxis, TRUE);
   }

void CMessageBoxExplorerDlg::OnBnClickedCopyModality()
   {
    toClipboard(&x_Modality, TRUE);
   }

void CMessageBoxExplorerDlg::OnBnClickedCopyAlignment()
   {
    toClipboard(&x_Alignment, TRUE);
   }

void CMessageBoxExplorerDlg::OnBnClickedCopyButtons()
   {
    toClipboard(&x_Buttons, TRUE);
   }

void CMessageBoxExplorerDlg::OnBnClickedCopyAPIs()
   {
    toClipboard(&x_APIs, TRUE);
   }

void CMessageBoxExplorerDlg::OnBnClickedCopyParent()
   {
    toClipboard(&x_Parent, TRUE);
   }

void CMessageBoxExplorerDlg::OnBnClickedCopyAll()
   {
    ShowCopyButtons(SW_HIDE);
    toClipboard(this, TRUE);
    updateControls();
   }
   
